#!/usr/bin/env python

# This CGI script connects to Panoptis' web port, makes a request,
# accepts data and formats it to show it to the user.

import socket, string, cgi, sys, os

PANOPTIS_PORT = 9002

def toksrt(item1, item2):
	try:
		it1 = string.atoi(item1[0])
		it2 = string.atoi(item2[0])
	except:
		return 1
	if (it1 < it2):
		return 1
	elif (it1 == it2):
		return 0
	else:
		return -1

def hostsrt(item1, item2):
	if (item1[0] < item2[0]):
		return -1
	elif (item1[0] == item2[0]):
		return 0
	else:
		return 1

print """Content-type: text/html
"""

f = cgi.FieldStorage()

s = socket.socket(socket.AF_INET, socket.SOCK_STREAM, socket.IPPROTO_IP)
s.connect(('', PANOPTIS_PORT))

if not f.has_key("op"):
	s.send("LIST\n")

	str = ''
	b = s.recv(1024)
	while (len(b)):
		str = str + b
		b = s.recv(1024)

	s.close()

	lines = string.split(str, '\n')
	addr = []
	for l in lines:
		s = string.strip(l)
		if s and (s != '.'):
			try:
				n = socket.gethostbyaddr(s)
				h = (n[0], s)
			except:
				h = (s, s)
			addr.append(h)

	print """
	<html>
	<head>
	<title>Panoptis traffic information</title>
	</head>
	<body>
	<form action="/cgi-bin/pview.py" method="get">
		<input type="hidden" name="op" value="data">
		Source interface: <select name="src">
		<option value="0">Any</option>
	"""

	addr.sort(hostsrt)

	for s in addr:
		print '<option value="%s">'%(s[1]) + s[0] + "</option>"

	print """</select><p>
		Destination interface: <select name="dst">
		<option value="0">Any</option>
	"""

	for s in addr:
		print '<option value="%s">'%(s[1]) + s[0] + "</option>"

	print """</select><p>
	<input type="submit">
	</form>
	</body>
	</html>
	"""

elif f["op"].value == "data":
	if (not f.has_key("src")) or (not f.has_key("dst")):
		print "Either source or destination is not present"
		sys.exit(0)

	s.send("DATA 1 %s %s\n"%(f["src"].value, f["dst"].value))

	str = ''
	b = s.recv(1024)
	while (len(b)):
		str = str + b
		b = s.recv(1024)

	s.close()
	lines = string.split(str, '\n')
	res = []
	for l in lines:
		s = string.split(string.strip(l))
		if s and (s != '.'):
			res.append(s)

	res.sort(toksrt)
	if (len(res) <= 50):
		res = res[:-1]
	else:
		res = res[:50]

	print """
<html>
	<head>
	<title>Panoptis traffic information</title>
	<META HTTP-EQUIV="Refresh" CONTENT="300">
	</head>
<body>
	<table border="0" align="center" width="60%">
	<tr>
		<td align="left">
			<b>Showing up to 50 entries:</b>
		</td>
		<td align="right">
			(<a href="/cgi-bin/pview.py?op=data&src=0&dst=0">All interfaces</a>)
		</td>
	</tr>
	</table>
	<P>
	<table border="1" align="center">
	<tr><th align="center">Prev flows</td>
	<th align="center">Prev packets</td>
	<th align="center">Input interface</td>
	<th align="center">Output interface</td>
	<th align="center">Top destination (flows)</td>
	<th align="center">Top destination (packets)</td></tr>
"""
	for tok in res:
		try:
			inif = socket.gethostbyaddr(tok[2])[0]
		except:
			inif = tok[2]
		try:
			outif = socket.gethostbyaddr(tok[3])[0]
		except:
			outif = tok[3]

		print """
	<tr>
		<td align="center">%s</td>
		<td align="center">%s</td>
		<td align="center"><a href="/cgi-bin/pview.py?op=data&src=%s&dst=0">%s</a></td>
		<td align="center"><a href="/cgi-bin/pview.py?op=data&src=0&dst=%s">%s</a></td>
		<td align="center"><a href="/cgi-bin/pview.py?op=whois&h=%s">%s</a> (%s)</td>
		<td align="center"><a href="/cgi-bin/pview.py?op=whois&h=%s">%s</a> (%s)</td>
	</tr>
""" % (tok[0], tok[1], tok[2], inif, tok[3], outif, tok[4], tok[4], tok[6], tok[5], tok[5], tok[7])
	print """
	</table>
	</body>
	</html>
"""

elif f["op"].value == "whois":
	if (not f.has_key("h")):
		print "No host to query"
		sys.exit(0)

	try:
		h = socket.gethostbyaddr(f["h"].value)[0]
	except:
		h = f["h"].value

	print """
	<html>
	<body>
	<b>Hostname:</b> %s<p>
	<b>Whois information:</b><p>
""" % (h)

	fp = os.popen("/usr/bin/whois " + f["h"].value)
	lines = fp.readlines()
	fp.close()
	for line in lines:
		print string.strip(line) + "<br>\n"
	
	print """
	</body>
	</html>
"""

elif f["op"].value == "attacks":
	print ""
else:
	print "Unknown operation"

